<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2006 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Dieses Modul basiert auf:
 *     Usermap, Copyright (C) 2004 by 
 *      Andreas Trsch http://www.nukemodule.de
 *      Bernd Mnt http://www.bmservices.de
 * Dieses Modul basiert auf:
 *     PHPKit Usermap 1.2 von www.fletchers-corner.de (28 Oktober 2003)
 * Plz/Geodaten von OpenGeoDB - freie Geokoordinaten-Datenbank, http://opengeodb.de
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

class Map {
    var $img;
    var $size_x;
    var $size_y;

    var $max;
    var $min;
    /**
     * prepares the image generation and inits the internal variables
     * 
     * @param  $size_x width of the generated image
     * @param  $size_y height of the generated image
     */

    function Map ($file)
    {
        $this->img = imagecreatefrompng($file);

        $this->size_x = imagesx($this->img);
        $this->size_y = imagesy($this->img);
    } 

    /**
     * set the range of the map which has to be generated
     * 
     * @param  $x1 lower longitude
     * @param  $x2 higher longitude
     * @param  $y1 lower latitude
     * @param  $y2 higher latitude
     */

    function setRange($x1, $x2, $y1, $y2)
    {
        $this->min = array('x' => $x1, 'y' => $y1);
        $this->max = array('x' => $x2, 'y' => $y2);
    } 

    /**
     * return the generated map in buffer
     */

    function dumpbuffer()
    {
        ob_start();
        imagepng($this->img);
        $buffer = ob_get_contents();
        ob_end_clean();
        return $buffer;
    } 

    var $imageMap = array();

    /**
     * Adds a Image to the map
     */

    function addImg($laenge, $breite, $bild, $radius)
    {
        $pin = imagecreatefrompng($bild);
        $MyOffset = floor($radius / 2);
        $MyX = $laenge - $MyOffset;
        $MyY = $breite - $MyOffset;
        imagecopy($this->img, $pin, $MyX, $MyY, 0, 0, $radius, $radius);
    } 

    /**
     * Adds a Pin to the map
     */
    function addPin($x, $y, $bild, $radius, $DrawInline = 'true', $alt = '', $href = '', $onclick = '', $onmouseover = '', $onmouseout = '')
    {
        $pin = imagecreatefrompng($bild);
        $MyOffset = floor($radius / 2);
        $MyX = $x - $MyOffset;
        $MyY = $y - $MyOffset;
        if ($DrawInline) {
            imagecopy($this->img, $pin, $MyX, $MyY, 0, 0, $radius, $radius);
        } 
        if ($x == 0) {
            print $alt;
        } 
        $this->imageMap[] = array("image" => $bild,
            "href" => $href,
            "alt" => $alt,
            "onclick" => $onclick,
            "onmouseover" => $onmouseover,
            "onmouseout" => $onmouseout,
            "x" => $x,
            "y" => $y,
            "r" => $MyOffset
            );
    } 

    /**
     * Creates an image map (html)
     * 
     * @access public 
     * @param string $name name of the ImageMap
     * @return string html
     */
    function getImageMap($name = "map")
    {
        $html = '<map name="' . $name . '">' . "\n";
        foreach($this->imageMap AS $koord) {
            $html .= '<area shape="circle" coords="' . round($koord['x']) . ',' . round($koord['y']) . ',' . $koord['r'] . '" href="' . $koord['href'] . '" alt="' . $koord['alt'] . '" target="profiles" ';
            if ($koord['onclick'] != '') {
                $html .= ' onclick="' . $koord['onclick'] . '" ';
            } 
            if ($koord['onmouseover'] != '') {
                $html .= 'onmouseover="' . $koord['onmouseover'] . '" ';
            } 
            if ($koord['onmouseout'] != '') {
                $html .= 'onmouseout="' . $koord['onmouseout'] . '" ';
            } 
            $html .= ">\n";
        } 
        $html .= "</map>\n";
        return $html;
    } 
} 

?>